#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "gun2eight4xi.py">
#<abstract4xi abstract = "guns to direction eight"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'gun2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from dummyprocess4xi import DummyProcess4Xi

from shoot2eight4xi import shoot2eight4xi

from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

      
#"
#"/>
    
             
# -----------------------------------------------------------------------------------------------------
#<function4xi function = "gun2eight4xi" usage = "
#   gun for Process4Xi-8
#"> 
# -----------------------------------------------------------------------------------------------------
       
def gun2eight4xi(queue2work, channel2consume, channel2publish):
    '''
    guns for Process4Xi-8
    '''    
        
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    print('=' *33)
    print("(STEP 1/33) OF GUN2EIGHT4XI, START TIME: ", time4xi()) 
    print('=' *33)
    #
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    queue2work4eight = queue2work
    
    print('~' *33)
    print("(STEP 2/33) OF GUN2EIGHT4XI, QUEUE2WORK4EIGHT: ", queue2work4eight)
    print('~' *33)
    # <queue4xi.Queue4Xi object at 0x02DA28F0> 
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    channel2consume4eight = channel2consume
    print('~' *33)
    print("(STEP 3/33) OF GUN2EIGHT4XI, CHANNEL2CONSUME4EIGHT: ", channel2consume4eight)
    print('~' *33)
    # <read-write PipeConnection, handle 296> 
    
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     
    channel2publish4eight = channel2publish
    print('~' *33)
    print("(STEP 4/33) OF GUN2EIGHT4XI, CHANNEL2PUBLISH4EIGHT: ", channel2publish4eight)
    print('~' *33)
    # <read-write PipeConnection, handle 300> 
        
    
    # ---------------------------------------------------------------------------------------------    
    # GETTING FROM QUEUE
    # --------------------------------------------------------------------------------------------- 
        
    try:
        message2qet4eight = queue2work4eight.get()
        print("(STEP 5A/33) OF GUN2EIGHT4XI - MESSAGE2QET4EIGHT GOT: ", message2qet4eight) 
        # <copy4xi>copy2eight</copy4xi>
        
        if message2qet4eight == "<copy4xi>copy2eight</copy4xi>":
            message2put4eight = "<roger4xi>roger2eight</roger4xi>"
            print("(STEP 5B/33) OF GUN2EIGHT4XI - SET MESSAGE2PUT4EIGHT TO: ", message2put4eight) 
            # <roger4xi>roger2eight</roger4xi>
        else:
            print("(STEP 5c/33) OF GUN2EIGHT4XI - *** UNREGONIZED MESSAGE GOT: ", message2qet4eight)           
            message2put4eight = "<negative4xi>negative2eight</negative4xi>"
            print("(STEP 5d/33) OF GUN2EIGHT4XI - SET MESSAGE2PUT4EIGHT TO: ", message2put4eight)             
    except:
        message2put4eight = "<negative4xi>negative2eight</negative4xi>"
    
    
    # ---------------------------------------------------------------------------------------------    
    # PUTTING TO QUEUE
    # --------------------------------------------------------------------------------------------- 
    print("(STEP 6A/33) OF GUN2EIGHT4XI - TRYING TO PUT MESSAGE2PUT4EIGHT: ", message2put4eight)                                  
    try:         
        queue2work4eight.put(message2put4eight) 
        print('~' *33)
        print("(STEP 6B/33) OF GUN2EIGHT4XI - PUT TO QUEUE2WORK4EIGHT: ", queue2work4eight, ' MESSAGE2PUT4EIGHT: ', message2put4eight)
        print('~' *33)
        # PUT TO QUEUE2WORK4EIGHT:  <queue4xi.Queue4Xi object at 0x02DA28F0>  MESSAGE2PUT4EIGHT:  <roger4xi>roger2eight</roger4xi> 
        
    except:
        print("(STEP 6c/33) OF GUN2EIGHT4XI *** FAILED TO PUT TO QUEUE2WORK4EIGHT: ", queue2work4eight, ' MESSAGE2PUT4EIGHT: ', message2put4eight)
                   
    # ---------------------------------------------------------------------------------------------    
    # RECEIVING FROM PIPE CONSUMER CHANNEL
    # ---------------------------------------------------------------------------------------------     

    print("(STEP 7A/33) OF GUN2EIGHT4XI - TRYING TO RECEIVE FROM CHANNEL2CONSUME4EIGHT: ", channel2consume4eight)
    try:
        message2receive4eight = channel2consume4eight.recv()
        print("(STEP 7B/33) OF GUN2EIGHT4XI - RECEIVED MESSAGE2RECEIVE4EIGHT: ", message2receive4eight)
        # <copy4xi>copy2eight</copy4xi>
        
        if message2receive4eight == "<copy4xi>copy2eight</copy4xi>":
            message2send4eight = "<roger4xi>roger2eight</roger4xi>"
            print("(STEP 7C/33) OF GUN2EIGHT4XI - SET MESSAGE2SEND4EIGHT: ", message2send4eight)
            # <roger4xi>roger2eight</roger4xi>
        else:
            message2send4eight = "<negative4xi>negative2eight</negative4xi>"
            print("(STEP 7D/33) OF GUN2EIGHT4XI - SET MESSAGE2SEND4EIGHT: ", message2send4eight)        
    except:
        print("(STEP 7E/33) OF GUN2EIGHT4XI - *** EXCEPTION WITH CHANNEL2CONSUME4EIGHT.RECV: ", channel2consume4eight.recv) 
        message2send4eight = "<negative4xi>negative2eight</negative4xi>"
        print("(STEP 7F/33) OF GUN2EIGHT4XI - SET MESSAGE2SEND4EIGHT: ", message2send4eight)       
            
        
            
    # ---------------------------------------------------------------------------------------------
    # SEND DATA TO THE PIPE'S PUBLISHER CHANNEL 
    # ---------------------------------------------------------------------------------------------
    print("(STEP 8A/33) OF GUN2EIGHT4XI - TRYING TO SEND DATA TO CHANNEL2PUBLISHER4EIGHT: ", channel2publish4eight)
    # 
    try:         
        channel2publish4eight.send(message2send4eight)
        print("(STEP 8B/33) OF GUN2EIGHT4XI - SENT MESSAGE2SEND4EIGHT: ", message2send4eight, " CHANNEL2PUBLISHER4EIGHT: ", channel2publish4eight)
        # SENT MESSAGE2SEND4EIGHT:  <roger4xi>roger2eight</roger4xi>  CHANNEL2PUBLISHER4EIGHT:  <read-write PipeConnection, handle 300> 
    except:
        print("(STEP 8C/33) OF GUN2EIGHT4XI - *** FAILED TO SEND MESSAGE2SEND4EIGHT: ", message2send4eight, " CHANNEL2PUBLISHER4EIGHT: ", channel2publish4eight) 
    
    # ---------------------------------------------------------------------------------------------    
    # PERFORMING MANOEUVRE 
    # --------------------------------------------------------------------------------------------- 
    print("(STEP 9A/33) OF GUN2EIGHT4XI - TRYING MANOEUVRE SPHERE2WNB: (-X,-Y,-Z) - WEST, NORTH, BACKWARDS")     
    ack2function = False
    if ack2function is True:
        # -----------------------------------------------------------------------------------------    
        # Using the function to shoot - this approach works, but blocks return to MainProcess4Xi! 
        # -----------------------------------------------------------------------------------------        
        try: 
            sphere2wnb = shoot2eight4xi(start2distance = 100, interval2distance = 100, max2layer = 100, max2count = 200, marginal2count = 1.2, sign2x = '-', sign2y = '-', sign2z = '-',
                                        max2iterate = 4200, increase2distance = None, change2a = pi/60 , change2e = pi/60, increase2a = 0.01, increase2e = 0.01,
                                        start2plusa = 3.1991885189056037, max2plusa = 2*pi, min2plusa = pi/240, start2minusa = -pi/6 , max2minusa = -0.98*2*pi, min2minusa = -pi/240,
                                        start2pluse = 2.1335987755982972, max2pluse = pi, min2pluse = pi/240, start2minuse = -pi/6, max2minuse = -0.98*pi, min2minuse = -pi/240)                    
                               
            print("(STEP 9B/33) OF GUN2EIGHT4XI - PERFORMED MANOEUVRE SPHERE2WNB: (-X,-Y,-Z) - WEST, NORTH, BACKWARDS")       
            # for results search (STEP 32/33) OF SHOOT2EIGHT4XI - STATISTICS FOR REQUIRED           
        except:
            print("(STEP 9C/33) OF GUN2EIGHT4XI *** FAILED TO PERFORM MANOEUVRE SPHERE2WNB: (-X,-Y,-Z) - WEST, NORTH, BACKWARDS")        
    else:
        pass
        
    ack2process = True
    if ((ack2process is True) and (ack2function is False)):
        # -----------------------------------------------------------------------------------------    
        # Using the dummy process to shoot - this approach tries faster return to MainProcess4Xi  
        # -----------------------------------------------------------------------------------------      
        print("(STEP 10A/33) OF GUN2EIGHT4XI - CREATING A DUMMY PROCESS4XI")  
        ack2dummy = False
        
        # -----------------------------------------------------------------------------------------    
        # create the dummy process object 
        # -----------------------------------------------------------------------------------------          
        # to be checked in test_sphere4xi.txt: OK SHOOTING OF SHOOT2TWO4XI
        # example: ACCEPTED SHOTS  95 >=  80  ORIGINALLY REQUIRED, MARIGINAL:  1.2        
        try:                            # latest ok shot
            start2distance = 10         # 3300
            interval2distance = 10      # 100 
            max2layer = 10              # 100 
            marginal2layer = 1.2        # 1.2
            max2count = 80              # 100    
            
            marginal2count = 1.2
            sign2x = '-'
            sign2y = '-'
            sign2z = '-'
            max2iterate = 2400
            
            start2plusa = 3.1991885189056037
            max2plusa = 2*pi
            min2plusa = pi/240
            start2minusa = -pi/6
            max2minusa = -0.98*2*pi
            min2minusa = -pi/240
            
            start2pluse = 2.1335987755982972
            max2pluse = pi
            min2pluse = pi/240
            start2minuse = -pi/6
            max2minuse = -0.98*pi
            min2minuse = -pi/240
            
            increase2distance = 1
            change2a = pi/60
            change2e = pi/60
            increase2a = 0.01
            increase2e = 0.01        
                    
            dummy2eight = DummyProcess4Xi(target=shoot2eight4xi, 
                                               args =(queue2work4eight,
                                                      channel2consume4eight, channel2publish4eight,
                                                      start2distance, interval2distance, max2layer, marginal2layer,max2count,
                                                      marginal2count, sign2x, sign2y, sign2z, max2iterate, 
                                                      start2plusa, max2plusa, min2plusa, start2minusa, max2minusa, min2minusa,
                                                      start2pluse, max2pluse, min2pluse, start2minuse, max2minuse, min2minuse,
                                                      increase2distance, change2a, change2e, increase2a, increase2e))

          
            print("(STEP 10B/33) OF GUN2EIGHT4XI - CREATED DUMMY_PROCESS4XI OBJECT DUMMY2EIGHT: ", dummy2eight) 
            # <DummyProcess4Xi(Thread-8, initial)> 
            
            ack2dummy = True
        except:
            print("(STEP 10C/33) OF GUN2EIGHT4XI *** FAILED TO CREATE DUMMY_PROCESS4XI OBJECT DUMMY2EIGHT ***")
            ack2dummy = False
            
        # -----------------------------------------------------------------------------------------    
        # start the dummy process object
        # -----------------------------------------------------------------------------------------              
        if ack2dummy is True:
            print("(STEP 10D/33) OF GUN2EIGHT4XI - STARTING THE DUMMY PROCESS4XI TIME: ", time4xi())  
            ack2start = False
            try:      
                dummy2eight.start() 
                print("(STEP 10E/33) OF GUN2EIGHT4XI - STARTED THE DUMMY PROCESS4XI DUMMY2EIGHT: ", dummy2eight)

                ack2start = True
            except:
                print("(STEP 10F/33) OF GUN2EIGHT4XI *** FAILED TO START THE DUMMY PROCESS4XI ***")
        else:
            print("(STEP 10G/33) OF GUN2EIGHT4XI ** YIELDED STARTING THE DUMMY PROCESS4XI - ACK2DUMMY: ", ack2dummy)
            ack2start = False 
    else:
        print("(STEP 10H/33) OF GUN2EIGHT4XI ** YIELDED STARTING THE DUMMY PROCESS4XI - ACK2DUMMY: ", ack2dummy, " ACK2FUNCTION: ", ack2function)
                                
                                                                           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------     

    print('=' *33)
    print("(STEP 11/33) OF GUN2EIGHT4XI - RETURNING TIME: ", time4xi())
    print('=' *33)
    # 
    
#</function4xi>

#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_sphere4xi.txt
#   sense-test-sphere4xi.xml
#   reason-test-sphere4xi.xml
#   ace-test-sphere4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of gun2eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
